## eprover 3.2.5+ds

=== Makefile ===
#------------------------------------------------------------------------
#
# File  : Makefile (top level make file for E and its libraries)
#
# Author: Stephan Schulz
#
# Top level make file. Check Makefile.vars for system-dependend tool
# selection and compilation options.
#
# Changes
#
# Created: Sun Jul  6 22:55:11 MET DST 1997
#
#------------------------------------------------------------------------

.PHONY: all depend remove_links clean cleandist default_config debug_config distrib fulldistrib top links tags rebuild install config remake documentation E man starexec starexec-src

include Makefile.vars

# Project specific variables


PROJECT  = $(shell basename `pwd`)

LIBS     = CONTRIB BASICS INOUT TERMS ORDERINGS CLAUSES PROPOSITIONAL LEARN \
           PCL2 HEURISTICS CONTROL
HEADERS  = $(LIBS) EXTERNAL PROVER
CODE     = $(LIBS) SIMPLE_APPS EXTERNAL PROVER
PARTS    = $(CODE) DOC


all: E


# Generate dependencies

depend:
	@for subdir in $(CODE); do\
		cd $$subdir; touch Makefile.dependencies; $(MAKE) depend; cd ..;\
	done;

# Remove all automatically generated files

remove_links:
	@if [ -d include ]; then\
		cd include; rm -f *.h;\
	fi;
	@if [ -d lib ]; then\
		cd lib;     rm -f *.a;\
	fi;
	@rm -f PROVER/picosat

clean: remove_links
	@for subdir in $(PARTS); do\
		cd $$subdir; touch Makefile.dependencies;$(MAKE) clean; cd ..;\
	done;

cleandist: clean
	@rm -f *~ */*~

default_config:
	./configure
	@cat Makefile.vars| \
	gawk '/^NODEBUG/{print "NODEBUG    = -DNDEBUG -DFAST_EXIT";next}/^MEMDEBUG/{print "MEMDEBUG   = # -DCLB_MEMORY_DEBUG # -DCLB_MEMORY_DEBUG2";next}/^DEBUGGER/{print "DEBUGGER   = # -g -ggdb";next}/^PROFFLAGS/{print "PROFFLAGS  = # -pg";next}{print}' > __tmpmake__;mv __tmpmake__ Makefile.vars


debug_config:
	@cat Makefile.vars| \
	gawk '/^NODEBUG/{print "NODEBUG    = # -DNDEBUG -DFAST_EXIT";next}/^MEMDEBUG/{print "MEMDEBUG   = -DCLB_MEMORY_DEBUG # -DCLB_MEMORY_DEBUG2";next}{print}' > __tmpmake__;mv __tmpmake__ Makefile.vars

commit_id:
	echo '#define ECOMMITID "'`git rev-parse HEAD`'"' > PROVER/e_gitcommit.h


# Build a distribution
distrib: default_config commit_id man documentation cleandist
	@echo $(MYVAR)
	@echo "Did you think about: "
	@echo " - Changing the bibliographies to local version"
	@echo " - increasing the dev version number and committing to git?"
	@echo "    ??? "
	@echo "" > etc/NO_DISTRIB
	@cd ..; find $(PROJECT) -name ".git" -print >> $(PROJECT)/etc/NO_DISTRIB;\
		$(TAR) cfX - $(PROJECT)/etc/NO_DISTRIB $(PROJECT) |$(GZIP) - -c > $(PROJECT).tgz

# Include the GIT subdirecctories (and non-GPL files, of which there currently are none).
fulldistrib: man documentation cleandist default_config
	@echo "Warning: You are building a full archive!"
	@echo "Did you remember to increase the dev version number and commit to git?"
	@cd ..; $(TAR) cf - $(PROJECT)|$(GZIP) - -c > $(PROJECT)_FULL.tgz

# Build StarExec package. This is not supposed to be super-portable
# StarExec runs all binaries from its local bin/, so we cheat

starexec:
	echo $(STAREXECPATH)
	rm -rf $(STAREXECPATH)
	find . -name ".#*"  -exec rm {} \;
	make clean
	./configure --bindir="."
	make
	./configure --prefix=$(STAREXECPATH)
	make install

	make clean
	./configure --bindir="." --enable-ho
	make
	./configure --prefix=$(STAREXECPATH) --enable-ho
	make install

	cp etc/STAREXEC3.0/starexec_run* $(STAREXECPATH)/bin
	$(eval E_VERSION=`$$(STAREXECPATH)/bin/eprover --version | cut -d' ' -f1-2| sed -e 's/ /-/'`)
	cd $(STAREXECPATH); zip -r $(E_VERSION).zip bin man

starexec-src:
	echo $(STAREXECPATH)
	rm -rf $(STAREXECPATH)
	mkdir $(STAREXECPATH)
	find . -name ".#*"  -exec rm {} \;
	make distrib
	cp ../E.tgz $(STAREXECPATH)
	make clean
	./configure --bindir="."
	make
	./configure --prefix=$(STAREXECPATH)
	make install

	cp etc/STAREXEC3.0/starexec_run* $(STAREXECPATH)/bin
	cp etc/starexec_build $(STAREXECPATH)
	$(eval E_VERSION=`$$(STAREXECPATH)/bin/eprover --version | cut -d' ' -f1-2| sed -e 's/ /-/'`)
	cd $(STAREXECPATH); zip -r $(E_VERSION)_src.zip bin man E.tgz starexec_build



# Make all library parts
top: E

# Create symbolic links
links: remove_links
	@mkdir -p include
	@cd include; find .. -not -path '../include/*' -name "[^.]*.h" -exec $(LN) {} \;
	@mkdir -p lib
#	@cd lib;find .. -not -path '../lib/*' -name "[^.]*.a" -exec $(LN) {} \;
	@cd lib;\
        for subdir in $(LIBS); do\
                $(LN) ../$$subdir/$$subdir.a .;\
        done;
# @cd PROVER; $(LN) $(PICOSAT)/picosat



tags:
	etags-emacs `find . \( -name "*.[ch]" -or -name "*.py" \) -and \( -not -path "*include*" -and -not -name ".#*" \)`
#ctags-exuberant -e -R .
# etags */*.c */*.h
# cd PYTHON; make ptags

# Rebuilding from scratch
rebuild:
	echo 'Rebuilding with debug options $(DEBUGFLAGS)'
	$(MAKE) clean
	$(MAKE) config
	$(MAKE)

# Configure the whole package
config:
	echo 'Configuring build system'
	$(MAKE) links
	$(MAKE) depend
	cd CONTRIB; $(MAKE) config


# Configure and copy executables to the installation directory
install:
	-sh -c 'mkdir -p $(EXECPATH)'
	-sh -c 'development_tools/e_install PROVER/$(EPROVER_BIN) $(EXECPATH)'
	-sh -c 'development_tools/e_install PROVER/eprover-ho     $(EXECPATH)'
	-sh -c 'development_tools/e_install PROVER/epclextract    $(EXECPATH)'
	-sh -c 'development_tools/e_install PROVER/e_stratpar     $(EXECPATH)'
	-sh -c 'development_tools/e_install PROVER/eground        $(EXECPATH)'
	-sh -c 'development_tools/e_install PROVER/e_ltb_runner   $(EXECPATH)'
	-sh -c 'development_tools/e_install PROVER/e_deduction_server $(EXECPATH)'
	-sh -c 'development_tools/e_install PROVER/e_axfilter     $(EXECPATH)'
	-sh -c 'development_tools/e_install PROVER/checkproof     $(EXECPATH)'
	-sh -c 'development_tools/e_install PROVER/ekb_create     $(EXECPATH)'
	-sh -c 'development_tools/e_install PROVER/ekb_delete     $(EXECPATH)'
	-sh -c 'development_tools/e_install PROVER/ekb_ginsert    $(EXECPATH)'
	-sh -c 'development_tools/e_install PROVER/ekb_insert     $(EXECPATH)'
	-sh -c 'development_tools/e_install CONTRIB/picosat-965/picosat $(EXECPATH)'
	-sh -c 'mkdir -p $(MANPATH)'
	-sh -c 'development_tools/e_install DOC/man/eprover.1      $(MANPATH)'
	-sh -c 'development_tools/e_install DOC/man/epclextract.1  $(MANPATH)'
	-sh -c 'development_tools/e_install DOC/man/e_stratpar.1   $(MANPATH)'
	-sh -c 'development_tools/e_install DOC/man/eground.1      $(MANPATH)'
	-sh -c 'development_tools/e_install DOC/man/e_ltb_runner.1 $(MANPATH)'
	-sh -c 'development_tools/e_install DOC/man/e_deduction_server.1 $(MANPATH)'
	-sh -c 'development_tools/e_install DOC/man/e_axfilter.1   $(MANPATH)'
	-sh -c 'development_tools/e_install DOC/man/checkproof.1   $(MANPATH)'
	-sh -c 'development_tools/e_install DOC/man/ekb_create.1   $(MANPATH)'
	-sh -c 'development_tools/e_install DOC/man/ekb_delete.1   $(MANPATH)'
	-sh -c 'development_tools/e_install DOC/man/ekb_ginsert.1  $(MANPATH)'
	-sh -c 'development_tools/e_install DOC/man/ekb_insert.1   $(MANPATH)'


# Also remake documentation
remake: config rebuild documentation

README: README.md
	grep -v '```' README.md > README

documentation: README
	cd DOC; $(MAKE)

man: E
	mkdir -p DOC/man
	help2man -N -i DOC/bug_reporting PROVER/eprover      > DOC/man/eprover.1
	help2man -N -i DOC/bug_reporting PROVER/e_stratpar   > DOC/man/e_stratpar.1
	help2man -N -i DOC/bug_reporting PROVER/eground      > DOC/man/eground.1
	help2man -N -i DOC/bug_reporting PROVER/epclextract  > DOC/man/epclextract.1
	help2man -N -i DOC/bug_reporting PROVER/e_ltb_runner > DOC/man/e_ltb_runner.1
	help2man -N -i DOC/bug_reporting PROVER/e_deduction_server > DOC/man/e_deduction_server.1
	help2man -N -i DOC/bug_reporting PROVER/e_axfilter   > DOC/man/e_axfilter.1
	help2man -N -i DOC/bug_reporting PROVER/checkproof   > DOC/man/checkproof.1
	help2man -N -i DOC/bug_reporting PROVER/ekb_create   > DOC/man/ekb_create.1
	help2man -N -i DOC/bug_reporting PROVER/ekb_delete   > DOC/man/ekb_delete.1
	help2man -N -i DOC/bug_reporting PROVER/ekb_ginsert  > DOC/man/ekb_ginsert.1
	help2man -N -i DOC/bug_reporting PROVER/ekb_insert   > DOC/man/ekb_insert.1

# Build the single libraries
E: links
	@for subdir in $(CODE); do\
		cd $$subdir; touch Makefile.dependencies; $(MAKE); cd ..;\
	done;

J ?= 4
benchpress-quick:
	@echo "run provers on example problems..."
	benchpress run -j $(J) -c benchpress.sexp --task eprover-quick-test --progress

.PHONY: benchpress

=== BASICS/Makefile ===
#------------------------------------------------------------------------
#
# File  : Makefile for BASICS.a library of generic data types and
# algorithms.
#
# Author: Stephan Schulz
#
# Created: Sun Jul  6 22:55:11 MET DST 1997
#
#------------------------------------------------------------------------

include ../Makefile.vars

# Project specific variables

PROJECT = BASICS
LIB     = $(PROJECT).a

all: $(LIB)

depend: *.c *.h
	$(MAKEDEPEND)

# Remove all automatically generated files

clean:
	@rm -f *.o  *.a

# Services (provided by the master Makefile)

include ../Makefile.services

# Build the  library

BASIC_LIB = clb_error.o clb_memory.o clb_os_wrapper.o \
            clb_dstrings.o clb_verbose.o\
            clb_stringtrees.o clb_numtrees.o clb_numxtrees.o \
            clb_floattrees.o clb_pstacks.o\
            clb_pqueue.o clb_dstacks.o clb_ptrees.o clb_quadtrees.o\
            clb_regmem.o clb_permastrings.o \
	    clb_objtrees.o clb_objmaps.o clb_fixdarrays.o\
            clb_plist.o clb_pdarrays.o clb_pdrangearrays.o \
            clb_ddarrays.o clb_sysdate.o \
            clb_intmap.o \
            clb_simple_stuff.o clb_partial_orderings.o \
            clb_plocalstacks.o clb_min_heap.o

MIN_HEAP = clb_min_heap.o

min_heap: $(MIN_HEAP)
	$(LD) -o min_heap  $(BASIC_LIB) -lm

$(LIB): $(BASIC_LIB)
	$(AR) $(LIB) $(BASIC_LIB)

include Makefile.dependencies

=== CLAUSES/Makefile ===
#------------------------------------------------------------------------
#
# File  : Makefile for clauses part of the clib library
#
# Author: Stephan Schulz
#
# Changes
#
# <1> Fri Mar 13 17:09:13 MET 1998
#     New
#
#------------------------------------------------------------------------

include ../Makefile.vars

# Project specific variables

PROJECT = CLAUSES
LIB     = $(PROJECT).a

all: $(LIB)

depend: *.c *.h
	$(MAKEDEPEND)

# Remove all automatically generated files

clean:
	@touch does_exist.o does_exist.a; rm *.o  *.a

# Services (provided by the master Makefile)

include ../Makefile.services

CLAUSE_LIB = ccl_ext_index.o ccl_neweval.o ccl_eqn.o ccl_eqnlist.o \
             ccl_clauseinfo.o ccl_clauses.o\
	     ccl_tformulae.o ccl_formula_wrapper.o ccl_formulasets.o \
             ccl_f_generality.o ccl_sine.o ccl_garbage_coll.o ccl_tcnf.o \
             ccl_propclauses.o\
             ccl_tautologies.o ccl_clausepos.o ccl_clausecpos.o \
             ccl_pdtrees.o ccl_freqvectors.o \
             ccl_fcvindexing.o ccl_clausesets.o ccl_unfold_defs.o\
             ccl_clausefunc.o ccl_formulafunc.o ccl_groundconstr.o\
             ccl_grounding.o ccl_g_lithash.o ccl_axiomsorter.o \
	     ccl_findex.o ccl_clausepos_tree.o ccl_subterm_tree.o \
             ccl_subterm_index.o ccl_overlap_index.o ccl_relevance.o\
             ccl_inferencedoc.o ccl_derivation.o ccl_paramod.o ccl_factor.o\
	     ccl_eqnresolution.o\
             ccl_rewrite.o ccl_unit_simplify.o ccl_subsumption.o \
             ccl_condensation.o ccl_context_sr.o \
             ccl_diseq_decomp.o ccl_def_handling.o ccl_splitting.o \
             ccl_global_indices.o ccl_satinterface.o\
             ccl_proofstate.o ccl_bce.o ccl_pred_elim.o

$(LIB): $(CLAUSE_LIB)
	$(AR) $(LIB) $(CLAUSE_LIB)

include Makefile.dependencies

=== CONTRIB/Makefile ===
#------------------------------------------------------------------------
#
# File  : Makefile
#
# This is the Makefile for contributed code of the E distribution. This is
# more convoluted than I like because it deals with PicoSat, which follows
# some conventions that are different frome the ones in E.
#
# Author: Stephan Schulz
#
# Created: Mon Nov 27 12:28:52 CET 2017
#
#------------------------------------------------------------------------

include ../Makefile.vars

PICOSAT = picosat-965

all: picosat

# Remove all automatically generated files

clean: $(PICOSAT)/makefile
	cd $(PICOSAT); $(MAKE) clean
	@rm  -f *.a


# Services (provided by the master Makefile)

include ../Makefile.services

config:
	cd $(PICOSAT); ./configure.sh -t

$(PICOSAT)/makefile: $(PICOSAT)/makefile.in
	make config

picosat: $(PICOSAT)/makefile
	cd $(PICOSAT); $(MAKE); $(MAKE)
	@if [ ! -h CONTRIB.a ]; then\
	   $(LN) $(PICOSAT)/libpicosat.a CONTRIB.a;\
	fi;

=== CONTROL/Makefile ===
#------------------------------------------------------------------------
#
# File  : Makefile for CONTROL part of thew CLIB library/E Prover
#
# Author: Stephan Schulz
#
# Changes
#
# <1> Mon Jun  8 11:09:27 MET DST 1998
#     New
#
#------------------------------------------------------------------------

include ../Makefile.vars

# Project specific variables

PROJECT = CONTROL
LIB     = $(PROJECT).a

all: $(LIB)

depend: *.c *.h
	$(MAKEDEPEND)

# Remove all automatically generated files

clean:
	@touch does_exist.o does_exist.a; rm *.o  *.a

# Services (provided by the master Makefile)

include ../Makefile.services

CONTROL_LIB = cco_simplification.o cco_factoring.o\
	      cco_eqnresolving.o cco_paramodulation.o cco_diseq_decomp.o\
	      cco_forward_contraction.o  cco_clausesplitting.o\
              cco_interpreted.o\
              cco_proofproc.o cco_proc_ctrl.o cco_gproc_ctrl.o\
              cco_batch_spec.o cco_einteractive_mode.o\
	      cco_sine.o cco_esession.o cco_eserver.o cco_scheduling.o\
	      cco_ho_inferences.o

$(LIB): $(CONTROL_LIB)
	$(AR) $(LIB) $(CONTROL_LIB)

include Makefile.dependencies

=== EXTERNAL/Makefile ===
#------------------------------------------------------------------------
#
# File  : Makefile for code outside the core E hierarchy.
#
# Author: Stephan Schulz
#
# Changes
#
# Created: Mon Apr 10 00:33:40 GMT 2000
#
#------------------------------------------------------------------------

include ../Makefile.vars

# Project specific variables

PROJECT = CSSCPA_filter
LIB     = $(PROJECT)

all: $(LIB)

depend: *.c *.h
	$(MAKEDEPEND)

# Remove all automatically generated files

clean:
	@touch does_exist.o does_exist.dSYM $(PROJECT)
	@rm -r *.o $(PROJECT) *.dSYM

# Services (provided by the master Makefile)

include ../Makefile.services

CSSCPA = CSSCPA_filter.o cex_csscpa.o \
            ../lib/CLAUSES.a ../lib/ORDERINGS.a ../lib/TERMS.a\
            ../lib/INOUT.a ../lib/BASICS.a ../lib/CONTRIB.a

$(LIB): $(CSSCPA)
	$(LD) -o CSSCPA_filter $(CSSCPA) $(LIBS)

include Makefile.dependencies

=== HEURISTICS/Makefile ===
#------------------------------------------------------------------------
#
# File  : Makefile for library of learning algorithms
#
# Author: Stephan Schulz
#
# Changes
#
# <1> Mon Feb 16 01:04:12 MET 1998
#     New
#
#------------------------------------------------------------------------

include ../Makefile.vars

# Project specific variables

PROJECT = HEURISTICS
LIB     = $(PROJECT).a

all: $(LIB)

depend: *.c *.h
	$(MAKEDEPEND)

# Remove all automatically generated files

clean:
	@touch does_exist.o does_exist.a; rm *.o  *.a

# Services (provided by the master Makefile)

include ../Makefile.services

HEURISTICS_LIB = che_wfcb.o che_wfcbadmin.o \
                 che_axiomscan.o \
		 che_clausefeatures.o \
	         che_prio_funs.o \
                 che_clausesetfeatures.o \
                 che_rawspecfeatures.o \
                 che_specsigfeatures.o \
	         che_clauseweight.o \
	         che_dagweight.o \
                 che_refinedweight.o \
		 che_varweights.o \
		 che_funweights.o \
		 che_orientweight.o \
		 che_fifo.o che_lifo.o \
                 che_learning.o \
                 che_simweight.o \
		 che_to_params.o \
	         che_hcb.o \
                 che_litselection.o \
	         che_proofcontrol.o \
		 che_hcbadmin.o \
		 che_heuristics.o \
                 che_fcode_featurearrays.o\
		 che_to_weightgen.o \
		 che_to_precgen.o \
		 che_to_autoselect.o \
                 che_axfilter.o \
		 che_strucweight.o \
	         che_prefixweight.o \
	         che_treeweight.o \
		 che_levweight.o \
	         che_tfidfweight.o \
	         che_termweights.o \
		 che_termweight.o \
	         che_random.o \
                 che_diversityweight.o \
				 che_new_autoschedule.o


$(LIB): $(HEURISTICS_LIB)
	$(AR) $(LIB) $(HEURISTICS_LIB)

include Makefile.dependencies

=== INOUT/Makefile ===
#------------------------------------------------------------------------
#
# File  : Makefile for io_lib of the CLIB library
#
# Author: Stephan Schulz
#
# Changes
#
# <1> Sun Jul  6 22:55:11 MET DST 1997
#     New
#
#------------------------------------------------------------------------

include ../Makefile.vars

# Project specific variables

PROJECT = INOUT
LIB     = $(PROJECT).a

all: $(LIB)

depend: *.c *.h
	$(MAKEDEPEND)

# Remove all automatically generated files

clean:
	@touch does_exist.o does_exist.a; rm *.o  *.a

# Services (provided by the master Makefile)

include ../Makefile.services

IO_LIB = cio_output.o cio_simplestuff.o cio_fileops.o \
	 cio_streams.o  cio_initio.o \
         cio_scanner.o cio_network.o cio_multiplexer.o \
         cio_basicparser.o cio_commandline.o \
         cio_filevars.o cio_tempfile.o cio_signals.o

$(LIB): $(IO_LIB)
	$(AR) $(LIB) $(IO_LIB)

include Makefile.dependencies

=== ORDERINGS/Makefile ===
#------------------------------------------------------------------------
#
# File  : Makefile for ORDERINGS sublibrary.
#
# Author: Stephan Schulz
#
# Changes
#
# <1> Thu Apr 30 03:11:31 MET DST 1998
#     New
#
#------------------------------------------------------------------------

include ../Makefile.vars

# Project specific variables

PROJECT = ORDERINGS
LIB     = $(PROJECT).a

all: $(LIB)

depend: *.c *.h
	$(MAKEDEPEND)

# Remove all automatically generated files

clean:
	@touch does_exist.o does_exist.a; rm *.o  *.a

# Services (provided by the master Makefile)

include ../Makefile.services

ORDER_LIB = cto_ocb.o cto_cmpcache.o cto_lpo.o cto_kbo.o cto_kbolin.o cto_orderings.o

$(LIB): $(ORDER_LIB)
	$(AR) $(LIB) $(ORDER_LIB)

include Makefile.dependencies

=== PCL2/Makefile ===
#------------------------------------------------------------------------
#
# File  : Makefile for the PCL2 stuff
#
# Author: Stephan Schulz
#
# Changes
#
# <1> Wed Mar 22 19:35:48 MET 2000
#     New
#
#------------------------------------------------------------------------

include ../Makefile.vars

# Project specific variables

PROJECT = PCL2
LIB     = $(PROJECT).a

all: $(LIB)

depend: *.c *.h
	$(MAKEDEPEND)

# Remove all automatically generated files

clean:
	@touch does_exist.o does_exist.a; rm *.o  *.a

# Services (provided by the master Makefile)

include ../Makefile.services

PCL2_LIB = pcl_idents.o pcl_positions.o pcl_expressions.o pcl_steps.o \
	   pcl_protocol.o pcl_miniclauses.o pcl_ministeps.o pcl_miniprotocol.o\
           pcl_lemmas.o pcl_analysis.o pcl_propanalysis.o pcl_proofcheck.o

$(LIB): $(PCL2_LIB)
	$(AR) $(LIB) $(PCL2_LIB)

include Makefile.dependencies

=== PROPOSITIONAL/Makefile ===
#------------------------------------------------------------------------
#
# File  : Makefile for the PROPOSITIONAL library
#
# Author: Stephan Schulz
#
# Changes
#
# <1> Thu Apr 24 17:09:00 CEST 2003
#     New
#
#------------------------------------------------------------------------

include ../Makefile.vars

# Project specific variables

PROJECT = PROPOSITIONAL
LIB     = $(PROJECT).a

all: $(LIB)

depend: *.c *.h
	$(MAKEDEPEND)

# Remove all automatically generated files

clean:
	@touch does_exist.o does_exist.a; rm *.o  *.a

# Services (provided by the master Makefile)

include ../Makefile.services

# Build the  library

PROP_LIB = cpr_propsig.o cpr_varset.o cpr_propclauses.o cpr_dpllformula.o cpr_dpll.o


$(LIB): $(PROP_LIB)
	$(AR) $(LIB) $(PROP_LIB)

include Makefile.dependencies

=== PROVER/Makefile ===
#------------------------------------------------------------------------
#
# File  : Makefile for E prover
#
# Author: Stephan Schulz
#
# Changes
#
# <1> Tue Jun  9 01:29:39 MET DST 1998
#     New
#
#------------------------------------------------------------------------

include ../Makefile.vars

# Project specific variables

PROJECT = $(EPROVER_BIN) e_ltb_runner e_stratpar e_deduction_server e_axfilter \
	  classify_problem epatternize e_client e_server\
          direct_examples epclanalyse epclextract checkproof eground\
          enormalizer edpll epcllemma \
          ekb_create ekb_insert ekb_ginsert ekb_delete $(EHOH)
LIB     = $(PROJECT)
all: $(LIB)

depend: *.c
	$(MAKEDEPEND)

# Remove all automatically generated files

clean:
	@rm -rf *.o $(PROJECT) *.dSYM termprops tsm_classify
	@rm -rf eprover-ho eprover

# Services (provided by the master Makefile)

include ../Makefile.services

# Build the programs

EPROVER = eprover.o ../lib/CONTROL.a ../lib/HEURISTICS.a\
            ../lib/LEARN.a\
            ../lib/CLAUSES.a ../lib/ORDERINGS.a ../lib/TERMS.a\
            ../lib/INOUT.a ../lib/BASICS.a  ../lib/CONTRIB.a

$(EPROVER_BIN): $(EPROVER)
	$(LD) -o $(EPROVER_BIN) $(EPROVER) $(LIBS)

E_LTB_RUNNER = e_ltb_runner.o ../lib/CONTROL.a ../lib/HEURISTICS.a\
            ../lib/CLAUSES.a ../lib/ORDERINGS.a ../lib/TERMS.a\
            ../lib/INOUT.a ../lib/BASICS.a ../lib/CONTRIB.a

e_ltb_runner: $(E_LTB_RUNNER)
	$(LD) -o e_ltb_runner $(E_LTB_RUNNER) $(LIBS)


E_STRATPAR = e_stratpar.o ../lib/CONTROL.a ../lib/HEURISTICS.a\
            ../lib/CLAUSES.a ../lib/ORDERINGS.a ../lib/TERMS.a\
            ../lib/INOUT.a ../lib/BASICS.a ../lib/CONTRIB.a

e_stratpar: $(E_STRATPAR)
	$(LD) -o e_stratpar $(E_STRATPAR) $(LIBS)


E_DEDUCTION_SERVER = e_deduction_server.o ../lib/CONTROL.a ../lib/HEURISTICS.a\
            ../lib/CLAUSES.a ../lib/ORDERINGS.a ../lib/TERMS.a\
            ../lib/INOUT.a ../lib/BASICS.a ../lib/CONTRIB.a

e_deduction_server: $(E_DEDUCTION_SERVER)
	$(LD) -o e_deduction_server $(E_DEDUCTION_SERVER) $(LIBS)


E_AXFILTER = e_axfilter.o ../lib/CONTROL.a ../lib/HEURISTICS.a\
            ../lib/CLAUSES.a ../lib/ORDERINGS.a ../lib/TERMS.a\
            ../lib/INOUT.a ../lib/BASICS.a ../lib/CONTRIB.a

e_axfilter: $(E_AXFILTER)
	$(LD) -o e_axfilter $(E_AXFILTER) $(LIBS)

E_SERVER = e_server.o ../lib/CONTROL.a ../lib/HEURISTICS.a\
            ../lib/CLAUSES.a ../lib/ORDERINGS.a ../lib/TERMS.a\
            ../lib/INOUT.a ../lib/BASICS.a

e_server: $(E_SERVER)
	$(LD) -o e_server $(E_SERVER) $(LIBS)

E_CLIENT = e_client.o ../lib/CONTROL.a ../lib/HEURISTICS.a\
            ../lib/CLAUSES.a ../lib/ORDERINGS.a ../lib/TERMS.a\
            ../lib/INOUT.a ../lib/BASICS.a ../lib/CONTRIB.a

e_client: $(E_CLIENT)
	$(LD) -o e_client $(E_CLIENT) $(LIBS)


EGROUND = eground.o ../lib/HEURISTICS.a\
            ../lib/CLAUSES.a ../lib/ORDERINGS.a ../lib/TERMS.a\
            ../lib/INOUT.a ../lib/BASICS.a ../lib/CONTRIB.a

eground: $(EGROUND)
	$(LD) -o eground $(EGROUND) $(LIBS)

ENORMALIZER = enormalizer.o ../lib/HEURISTICS.a\
            ../lib/CLAUSES.a ../lib/ORDERINGS.a ../lib/TERMS.a\
            ../lib/INOUT.a ../lib/BASICS.a ../lib/CONTRIB.a

enormalizer: $(ENORMALIZER)
	$(LD) -o enormalizer $(ENORMALIZER) $(LIBS)


EDPLL = edpll.o ../lib/PROPOSITIONAL.a ../lib/CLAUSES.a\
        ../lib/ORDERINGS.a ../lib/TERMS.a ../lib/INOUT.a\
	../lib/BASICS.a ../lib/CONTRIB.a

edpll: $(EDPLL)
	$(LD) -o edpll $(EDPLL) $(LIBS)

CLASSIFY = classify_problem.o ../lib/CONTROL.a ../lib/HEURISTICS.a\
            ../lib/CLAUSES.a ../lib/ORDERINGS.a ../lib/TERMS.a\
            ../lib/INOUT.a ../lib/BASICS.a ../lib/CONTRIB.a

classify_problem: $(CLASSIFY)
	$(LD) -o classify_problem $(CLASSIFY) $(LIBS)

EPATTERNIZE = epatternize.o ../lib/CONTROL.a ../lib/HEURISTICS.a\
            ../lib/LEARN.a\
            ../lib/CLAUSES.a ../lib/ORDERINGS.a ../lib/TERMS.a\
            ../lib/INOUT.a ../lib/BASICS.a ../lib/CONTRIB.a

epatternize: $(EPATTERNIZE)
	$(LD) -o epatternize $(EPATTERNIZE) $(LIBS)


# TERMPROPS = termprops.o ../lib/TERMS.a\
#             ../lib/INOUT.a ../lib/BASICS.a ../lib/PICOSAT.a

# termprops: $(TERMPROPS)
# 	$(LD) -o termprops $(TERMPROPS) $(LIBS)

DIRECT_EXAMPLES = direct_examples.o \
            ../lib/PCL2.a ../lib/CLAUSES.a ../lib/ORDERINGS.a \
            ../lib/TERMS.a ../lib/INOUT.a ../lib/BASICS.a ../lib/CONTRIB.a

direct_examples: $(DIRECT_EXAMPLES)
	$(LD) -o direct_examples $(DIRECT_EXAMPLES) $(LIBS)


EPCLANALYSE = epclanalyse.o \
        ../lib/PCL2.a ../lib/HEURISTICS.a ../lib/CLAUSES.a ../lib/ORDERINGS.a \
        ../lib/TERMS.a ../lib/INOUT.a ../lib/BASICS.a ../lib/CONTRIB.a

epclanalyse: $(EPCLANALYSE)
	$(LD) -o epclanalyse $(EPCLANALYSE) $(LIBS)


EPCLLEMMA = epcllemma.o \
        ../lib/PCL2.a ../lib/HEURISTICS.a ../lib/CLAUSES.a ../lib/ORDERINGS.a \
        ../lib/TERMS.a ../lib/INOUT.a ../lib/BASICS.a ../lib/CONTRIB.a

epcllemma: $(EPCLLEMMA)
	$(LD) -o epcllemma $(EPCLLEMMA) $(LIBS)


EPCLEXTRACT = epclextract.o \
        ../lib/PCL2.a ../lib/HEURISTICS.a ../lib/CLAUSES.a ../lib/ORDERINGS.a \
        ../lib/TERMS.a ../lib/INOUT.a ../lib/BASICS.a ../lib/CONTRIB.a

epclextract: $(EPCLEXTRACT)
	$(LD) -o epclextract $(EPCLEXTRACT) $(LIBS)

CHECKPROOF = checkproof.o \
        ../lib/PCL2.a ../lib/CLAUSES.a ../lib/ORDERINGS.a \
        ../lib/TERMS.a ../lib/INOUT.a ../lib/BASICS.a ../lib/CONTRIB.a

checkproof: $(CHECKPROOF)
	$(LD) -o checkproof $(CHECKPROOF) $(LIBS)

EKB_CREATE = ekb_create.o \
            ../lib/LEARN.a ../lib/CLAUSES.a \
            ../lib/ORDERINGS.a \
            ../lib/TERMS.a ../lib/INOUT.a ../lib/BASICS.a ../lib/CONTRIB.a

ekb_create: $(EKB_CREATE)
	$(LD) -o ekb_create $(EKB_CREATE) $(LIBS)

EKB_INSERT = ekb_insert.o \
            ../lib/LEARN.a ../lib/CLAUSES.a \
            ../lib/ORDERINGS.a \
            ../lib/TERMS.a ../lib/INOUT.a ../lib/BASICS.a ../lib/CONTRIB.a

ekb_insert: $(EKB_INSERT)
	$(LD) -o ekb_insert $(EKB_INSERT) $(LIBS)

EKB_GINSERT = ekb_ginsert.o \
	    ../lib/PCL2.a ../lib/LEARN.a ../lib/CLAUSES.a \
            ../lib/ORDERINGS.a \
            ../lib/TERMS.a ../lib/INOUT.a ../lib/BASICS.a ../lib/CONTRIB.a

ekb_ginsert: $(EKB_GINSERT)
	$(LD) -o ekb_ginsert $(EKB_GINSERT) $(LIBS)

EKB_DELETE = ekb_delete.o \
            ../lib/LEARN.a ../lib/CLAUSES.a \
            ../lib/ORDERINGS.a \
            ../lib/TERMS.a ../lib/INOUT.a ../lib/BASICS.a ../lib/CONTRIB.a

ekb_delete: $(EKB_DELETE)
	$(LD) -o ekb_delete $(EKB_DELETE) $(LIBS)

#TSM_CLASSIFY = tsm_classify.o \
#            ../lib/LEARN.a ../lib/CLAUSES.a \
#            ../lib/ORDERINGS.a \
#            ../lib/TERMS.a ../lib/INOUT.a ../lib/BASICS.a ../lib/CONTRIB.a

#tsm_classify: $(TSM_CLASSIFY)
#	$(LD) -o tsm_classify $(TSM_CLASSIFY) $(LIBS)


include Makefile.dependencies

=== debian/changelog ===
eprover (3.2.5+ds-1) unstable; urgency=medium

  * New upstream release.

 -- Julien Puydt <jpuydt@debian.org>  Fri, 18 Oct 2024 23:03:46 +0200

=== debian/control ===
Source: eprover
Maintainer: Debian Math Team <team+math@tracker.debian.org>
Uploaders: Julien Puydt <jpuydt@debian.org>
Section: math
Priority: optional
Standards-Version: 4.7.0
Homepage: https://eprover.org
Build-Depends: debhelper-compat (= 13), help2man, picosat
Rules-Requires-Root: no
Vcs-Git: https://salsa.debian.org/math-team/eprover.git
Vcs-Browser: https://salsa.debian.org/math-team/eprover

Package: eprover
Architecture: any
Depends: ${shlibs:Depends},${misc:Depends}
Description: Equational theorem prover
 This package provides tools to prove equational theorems:
 from a mathematical specification in many-sorted first-order
 logic with equality and an hypothesis/conjecture, it
 will look for a proof.

=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@

override_dh_auto_configure:
	# not an autotools build system!
	cp Makefile.vars Makefile.vars.orig

override_dh_auto_build:
	./configure --prefix=debian/tmp
	make rebuild
	make man

override_dh_auto_clean:
	dh_auto_clean
	find . -name Makefile.dependencies -delete
	find . -name "*.1" -delete
	if test -f Makefile.vars.orig; then \
		mv Makefile.vars.orig Makefile.vars; \
	fi
